Subject: [nfsv4] Some stuff on referrals/migration

From: "Noveck, Dave" <[email-masked]>
Date: Wed, 19 May 2004 06:31:15 -0700

At various testing events I've promised to write up my thoughts on how
to do 
referrals in v4, using the existing migration facility.  In many cases,
I
indicated that I would do it in a few weeks.  Well weeks have turned
into
(many) months and still no write-up.  Given that I'm going to see many
of 
you at the bakeathon, I've decided to avoid further embarrassment by
just
doing what I said I would, even though quite a bit late.  

Attached are two html files.  The first is a kind of cookbook that
explains 
how I think referrals should happen and what the client and server
should 
each do about points that are not so clear in RFC3530.  The second is
broadly
consistent with the first (I hope) but has a different focus.  It
explains
how the spec should be modified to be clearer about migration
implementation
issues including referral.  Since RFC3530 is not modifiable any more,
the 
discussion is in terms of the spec for v4.1, even though there are no
actual 
changes to the protocol (at least if one adopts the "correct"
interpretation
of v4.0, i.e. mine, on any unclear points).

---

From: Brent Callaghan <[email-masked]>
Date: Wed, 19 May 2004 12:54:27 -0700

Given that fs_locations has been in the spec for several years
now, and we're still trying to figure out how to implement it,
is it time to re-evaluate it ?

The NFS4ERR_MOVED error looks useful, but the work
required to extract fs_locations data seems very complex.

NFS users already use referrals via global paths in symbolic
links, e.g. "foo -> /net/otherserver/foo". They can do this
today with NFSv2 and NFSv3. Symlinks have the nice property
that they can be manipulated as filesystem objects.  It's
not clear how an fs_location attribute would be represented
on a server.

It seems that you could implement most of fs_locations in
a symbolic link, perhaps by embedding an NFS URL in the
link text.  Would it be better to explore this further?

	Brent

Noveck, Dave wrote:
 > At various testing events I've promised to write up my thoughts
 > on how to do referrals in v4, using the existing migration
 > facility.  In many cases, I indicated that I would do it in a
 > few weeks.  Well weeks have turned into (many) months and still
 > no write-up.  Given that I'm going to see many of you at the
 > bakeathon, I've decided to avoid further embarrassment by just
 > Attached are two html files.  The first is a kind of cookbook
 > that explains how I think referrals should happen and what the
 > client and server should each do about points that are not so
 > clear in RFC3530.  The second is broadly consistent with the
 > first (I hope) but has a different focus.  It explains how the
 > spec should be modified to be clearer about migration
 > implementation issues including referral.  Since RFC3530 is not
 > modifiable any more, the discussion is in terms of the spec for
 > v4.1, even though there are no actual changes to the protocol
 > (at least if one adopts the "correct" interpretation of v4.0,
 > i.e. mine, on any unclear points).

_______________________________________________
nfsv4 mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/nfsv4